QL language reference
#####################

Learn all about QL, the powerful query language that underlies the code scanning tool CodeQL.

.. toctree::
   :maxdepth: 1

   about-the-ql-language
   predicates
   queries
   types
   modules
   aliases
   variables
   expressions
   formulas
   annotations
   recursion
   lexical-syntax
   name-resolution
   evaluation
   language
   qldoc